Bug 1896407 - COPASI fails to build with Python 3.10: cmake detects Python 3.1 instead of Python3.10
Summary: COPASI fails to build with Python 3.10: cmake detects Python 3.1 instead of P...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: COPASI
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Antonio T. sagitter
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-10 13:45 UTC by Tomáš Hrnčiar
Modified: 2020-11-24 17:24 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-11-13 11:15:38 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-11-10 13:45:57 UTC
COPASI fails to build with Python 3.10.0a2.

/usr/lib/rpm/redhat/brp-python-bytecompile: line 82: /usr/bin/python3.1: No such file or directory

This seems like a problem with cmake. It was fixed in upstream (see: https://gitlab.kitware.com/cmake/cmake/-/merge_requests/5482), but might needs to be backported if COPASI bundles cmake scripts.  

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01758797-COPASI/

For all our attempts to build COPASI with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/COPASI/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Antonio T. sagitter 2020-11-12 13:18:26 UTC
I guess it's due to this command

execute_process(COMMAND "${PYTHON_EXECUTABLE}" -c "import sys;import platform; sys.stdout.write(platform.python_version()[:3])"

inside 

copasi/bindings/python/CMakeLists.txt

$ mock -r fedora-rawhide-python310 --no-clean --shell 'python3 -c "import sys;import platform; sys.stdout.write(platform.python_version()[:3])"'
INFO: mock.py version 2.6 starting (python version = 3.9.0)...
3.1
Finish: shell

How can i correctly port it for Python-3.10?

Comment 2 Miro Hrončok 2020-11-12 13:33:04 UTC
$ python3.10 -c "import sys;import platform; sys.stdout.write('{}.{}'.format(*platform.python_version_tuple()[:2]))"

Comment 3 Antonio T. sagitter 2020-11-12 14:49:06 UTC
Thank you Miro.

Hope last build release is fixed.


Note You need to log in before you can comment on or make changes to this bug.